=== debian/changelog ===
gnuradio (3.5.1-1) unstable; urgency=low

  * new upstream version, re-packaged from scratch with modern tools
	    closes: #642716, #645332, #394849, #616832, #590048, #642580,
	    #647018, #557050, #559640, #631863
  * CMake build

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 26 Feb 2012 21:26:16 -0500

gnuradio (3.4.1-1) unstable; urgency=low

  * New upstream release
  * comedi: fix to use comedi 0.8 API
  * support for the Ettus UHD interface
  * deprecating libusrp and libusrp2

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 28 Sep 2011 02:13:45 -0000

gnuradio (3.3.0.dfsg-1) UNRELEASED; urgency=low

  * new upstream version
  * add Vcs entries to the control file
  * use maintainer-clean target, always run bootstrap before configure
  * switch from using python-central to dh_python2
  * switch to doxygen-latex as a build dep, closes: #616252

 -- Bdale Garbee <bdale@gag.com>  Fri, 04 Mar 2011 08:33:04 -0700

gnuradio (3.2.2.dfsg-2) unstable; urgency=low

  * fix typos in short package descriptions, closes: #556572
  * resolve gnuradio-companion conflict with grc by renaming our binary,
    closes: #557050
  * accept patches that remove moc files and make libusrp packages depend
    on adduser, closes: #566564, #566565, #574209, #574231, #574209
  * stop delivering custom prefs.py, closes: #559640
  * lose the conflicts on python-wxgtk2.6, closes: #582486

 -- Bdale Garbee <bdale@gag.com>  Tue, 08 Jun 2010 20:05:02 -0600

gnuradio (3.2.2.dfsg-1) unstable; urgency=low

  * new upstream version, includes gcc4.3 support, closes: #474801, #524387
  * upstream tarball modified to elide unnecessary Altera-licensed files
  * merge debian/ content restructuring from upstream svn
  * change build-dep from fftw3-dev to libfftw3-dev, closes: #458231
  * fix problem with rebuilding, closes: #441739
  * no longer need to move to contrib now that sdcc is fully back in main,
    we just need to build depend on sdcc 2.9.0 or later, closes: #457402
  * rebuild reflects python-central file location change, closes: #490513
  * change Jack build depend to libjack-dev, closes: #527413

 -- Bdale Garbee <bdale@gag.com>  Sun, 01 Nov 2009 15:13:54 -0700

gnuradio (3.0.4-2) unstable; urgency=high

  * rebuild with new version number and upload to finally (?) recover from
    over-zealous removal in response to bug 453154
  * recommend udev instead of hotplug, closes: #448907

 -- Bdale Garbee <bdale@gag.com>  Sun, 23 Dec 2007 12:11:49 -0700

gnuradio (3.0.4-1) unstable; urgency=low

  * new upstream version
  * fix build failure with gcc-4.3 by adding a #include, closes: #420896

 -- Bdale Garbee <bdale@gag.com>  Tue, 14 Aug 2007 22:38:32 -0600

gnuradio (3.0.3-1) unstable; urgency=low

  * new upstream version
  * tweak gnuradio-doc package to eliminate spurious subdirectory level
  * add a usrp-doc binary package, recommended by the usrp package, and
    include xmlto in build dependencies so usrp_guide.html gets generated,
    closes: #407368

 -- Bdale Garbee <bdale@gag.com>  Sun, 11 Mar 2007 23:55:32 -0600

gnuradio (3.0.2-2) unstable; urgency=high

  * add run-time dependency on python-wxgtk2.6.  leaving urgency high since
    this would be a silly bug to release etch with if we can avoid it.

 -- Bdale Garbee <bdale@gag.com>  Mon,  4 Dec 2006 15:35:53 -0700

gnuradio (3.0.2-1) unstable; urgency=high

  * new upstream version, fixes FTBFS issues

 -- Bdale Garbee <bdale@gag.com>  Sun, 12 Nov 2006 14:52:33 -0800

gnuradio (3.0-3) unstable; urgency=high

  * put python-all-dev back in the build-depends list, closes: #398246
  * move gr-wxgui conflicts/depends to python-gnuradio, closes: #396302
  * fix up sections in control to match overrides

 -- Bdale Garbee <bdale@gag.com>  Sun, 12 Nov 2006 10:59:58 -0800

gnuradio (3.0-2) unstable; urgency=high

  * reworked package dependencies so that the 'gnuradio' binary package no
    longer depends on the pieces in contrib.  instead, the 'usrp' binary
    package in contrib now depends on all the USRP-related pieces.  A user
    who doesn't have a USRP board can just install 'gnuradio' and get all
    the relevant pieces, a USRP user needs to install both 'gnuradio' and
    'usrp'.  Closes: #394533
  * improve consistency of references to 'GNU Radio' as upstream project name
  * make the gnuradio package dependencies on python-gnuradio and python-usrp
    be version specific on suggestion from Ramakrishnan Muthukrishnan

 -- Bdale Garbee <bdale@gag.com>  Fri, 10 Nov 2006 00:39:38 -0800

gnuradio (3.0-1) unstable; urgency=low

  * new maintainer, new upstream version
  * Restructuring source and binary packages to follow upstream changes, more
    or less repackaging from scratch taking ideas from the previous packaging
    by Ramakrishnan Muthukrishnan and Steinar H. Gunderson.  This single
    source package replaces all of:
        gnuradio-core
        gnuradio-examples
        gr-audio-alsa
        gr-audio-jack
        gr-audio-oss
        gr-usrp
        gr-wxgui
        usrp
    In addition, the 'gnuradio' binary package is a new meta-package that
    conveniently depends on everything gnuradio related to ease installation.

 -- Bdale Garbee <bdale@gag.com>  Sun,  8 Oct 2006 13:28:21 -0600
